#include <stdio.h>
#include <string.h>
#include <math.h>
#include <string>
#include <assert.h>
#include <vector>
#include <algorithm>


using namespace std;

const int maxn = 11000;

struct kn{
	string name;
	int x,y,c;
	string child[4];
	void get(){
		char *s = new char[30];
		gets(s);
		name = s;
		scanf("%d %d\n%d\n",&x,&y,&c);
		for (int i = 0 ; i<c ; i++){
			gets(s);
			child[i] = s;
		}
	}
	bool operator <(kn a) const{
		return name<a.name;
	}
};

vector <kn> a;

void init(){
	int n;

	scanf("%d\n",&n);
	for (int i = 0 ; i<n ; i++){
		kn t;
		t.get();
		a.push_back(t);
	}
	sort(a.begin(),a.end());
}

int get(string s){
	int l = 0, r = a.size()-1;
	while (l<=r){
		int t = (l+r)>>1;
		if (a[t].name==s)
			return t;
		if (a[t].name<s){
			l = t+1;
		} else
			r = t-1;
	}
	assert(false);
}

	
int count(int n){
	int res = 1;
	for (int i = 0 ; i<a[n].c ; i++){
		res+=count(get(a[n].child[i]));
	}
	return res;
}

void solve(){
	int x,y;
	scanf("%d%d",&x,&y);
	for (int i = 0 ; i<a.size() ; i++){
		if (a[i].x==x && a[i].y==y){
			printf("%d",count(i));
		}
	}
}

int main(){
	freopen("input.txt","r",stdin);
	freopen("output.txt","w",stdout);
	init();
	solve();
	return 0;
}