#include<stdio.h>
#include <string.h>

const int maxn = 1010;

bool a[maxn][maxn];

int n;

#define nul(a) memset(a,0,sizeof(a))

char s[maxn*10];
bool isdigit(char c){
	return '0'<=c && c<='9';
}

bool readnumber(char s[], int &t){
	if (sscanf(s,"%d",&t)==1){
		int tek =0;
		while (isdigit(s[tek])==false){
			tek++;
		}
		while (isdigit(s[tek])){
			s[tek] = ' ';
		}
		return true;
	} else
		return false;
}

void init(){
	scanf("%d\n",&n);
	for (int i = 0 ; i<n ; i++){

		gets(s);
		
		int t;
		while (readnumber(s,t)){
			t--;
			a[i][t] = true;
		}
	}
}

int q[maxn];
bool was[maxn];

int yk = 0;

int bfs(int v){
	nul(was);
	yk =0 ;
	int res = 0;
	q[yk++] = v;
	res++;
	was[v] = true;
	int last = 0;
	int cnt = 0;
	while (last!=yk && cnt<3){
		int t = yk;
		cnt++;
		for (int i = last ; i<t ; i++){
			for (int j = 0 ; j<n ; j++){
				if (a[q[i]][j]){
					if (!was[j]){
						q[yk++] = j;
						res++;
						was[j] = true;
					}
				}
			}
		}
		last = t;
	}
	return res;
}

void solve(){
	int res = 1000000000;
	int id;

	for (int i = 0 ; i<n ; i++){
		int tres = bfs(i);
		if (tres<res){
			id = i;
			res = tres;
		}
	}
	printf("%d",id+1);
}

int main(){
	freopen("input.txt","r",stdin);
	freopen("output.txt","w",stdout);
	init();
	solve();
	return 0;
}