#pragma comment(linker,"/STACK:100000000")
#include <stdio.h>
#include <string.h>
#include <math.h>
#include <algorithm>
#include <string>
#include <assert.h>

using namespace std;

const int maxn = 10010;
const int maxc = 10010;
#define nul(a) memset(a,0,sizeof(a))
int per[20];


string nextname(){
	next_permutation(per,per+20);
	string res;
	for  (int i = 0 ; i<20 ; i++){
		res += char(per[i]+'A');
	}
	return res;
}

struct kn{
	string name,child[4];
	int x,y,num,id[4];
	void make(int cnt){
		name = nextname();
		x = cnt;
		y = cnt;
		num = 0;
	}
	void print(FILE *f){
		fprintf(f,"%s\n",name.c_str());
		fprintf(f,"%d %d\n%d\n",x,y,num);
		for (int i = 0 ; i<num ; i++){
			fprintf(f,"%s\n",child[i].c_str());
		}
	}
};

kn a[maxn];
int tek = 0;

bool was[maxn];

void dfs(int v, int n){
	was[v] = true;
	int cnt = 0,p[4];
	for (int i = 0 ; i<n ; i++){
		if (!was[i] && a[v].num<=3){
			a[v].child[a[v].num++] = a[i].name;
			a[v].id[a[v].num-1] = i;
			was[i] = true;
			p[a[v].num-1] = i;
		}
	}
	for (int i = 0 ; i<a[v].num ; i++)
		dfs(p[i],n);
}

void check(int v){
	was[v] = true;
	for (int i = 0 ; i<a[v].num ; i++){
		assert(was[a[v].id[i]]==false);
		check(a[v].id[i]);
	}
}

void makecoords(int v, int lx,int ly,int rx,int ry){
	int mx = (rx+lx)>>1;
	int my = (ly+ry)>>1;
	a[v].x = mx;


	a[v].y = my;
	if (a[v].num){
		makecoords(a[v].id[0],lx,ly,mx,my);
		makecoords(a[v].id[1],lx,my,mx,ry);
		makecoords(a[v].id[2],mx,ly,rx,my);
		makecoords(a[v].id[3],mx,my,rx,ry);
	}
}

void genrandtest(int n, int num){
	char name[100];
	sprintf(name,"%0*d",2,num);
	FILE *f = fopen(name,"w");
	//fprintf(f,"%d\n",n);
	for (int i = 0 ; i<n ; i++){
		a[i].make(i);
	}
	random_shuffle(a,a+n);
	//nul(was);
	int resx = a[0].x;
	int resy = a[0].y;
	//dfs(0,n);
	int cnt = 0;
	for (int i = 0 ; i<n ; i++){
		int tek = cnt;
		for (int j = 0 ; j<4 && cnt+1<n; j++){
			cnt++;
			a[i].child[j] = a[cnt].name;
			a[i].id[j] = cnt;
			a[i].num++;
		}
	}
	nul(was);
	check(0);
	cnt = n;
	for (int i = 0 ; i<n ; i++){
		if (a[i].num){
			for (int j = a[i].num ; j<4 ; j++){
				was[cnt] = true;
				a[cnt].make(cnt);
				a[i].num++;
				a[i].child[j] = a[cnt].name;
				a[i].id[j] = cnt++;
			}
		}
	}
	makecoords(0,-10000,-10000,10000,10000);
	resx = a[1].x;
	resy = a[1].y;
	for (int i = 0 ; i<n ; i++){
		assert(was[i]);
		assert(a[i].num==4 || a[i].num==0);
		for (int j = 0 ; j<i ; j++)
			assert(a[i].x!=a[j].x || a[i].y!=a[j].y);
	}
	random_shuffle(a,a+n);
	fprintf(f,"%d\n",cnt);
	for (int i = 0 ; i<cnt ; i++){
		a[i].print(f);
	}
	fprintf(f,"%d %d\n",resx,resy);
	fclose(f);
}

void genlongtest(int n, int num){
	char name[100];
	sprintf(name,"%0*d",2,num);
	FILE *f = fopen(name,"w");
	fclose(f);
}

int main(){
	int i;
	int cnt = 1;
	for (int i = 0 ; i<20 ; i++)
		per[i] = i+1;
	genrandtest(5,cnt++);
	genrandtest(10,cnt++);
	//genlongtest(10,cnt++);
	for (int i = 2 ; i<=10 ; i++){
		genrandtest(i*1000-10,cnt++);
		//genlongtest(i*2000,cnt++);
	}
	return 0;
}