#include <stdio.h>
#include <string.h>
#include <stdlib.h>

const int maxn = 30;
const int maxl = 1010;

#define nul(a) memset(a,0,sizeof(a))

void genrandomcase(FILE *f, int l){
	fprintf(f,"%d\n",rand()%729 + 1);
	for (int i = 0 ; i<l ; i++){
		if (rand()%1000<200)
			fprintf(f," ");
		else
			fprintf(f,"%c",rand()%26 + 'A');
	}
	fprintf(f,"\n");
}

bool a[30][30];

void gengoodcase(FILE *f, int l){
	nul(a);
	int pairs = rand()%729 +1;
	fprintf(f,"%d\n",pairs);
	char last = 'a';
	int tek = 0;
	for (int i = 0 ; i<l ; i++){
		int c;
		while (true){
			if (rand()%1000<200)
				c = 0;
			else
				c = rand()%26+1;
			if (!a[last][c] && tek<pairs){
				char p;
				tek++;
				if (c==0){
					p = ' ';
				} else
					p = 'A'+c-1;
				fprintf(f,"%c",p);
				a[last][c] = true;
				break;
			} else{
				char p;
				if (c==0){
					p = ' ';
				} else
					p = 'A'+c-1;
				fprintf(f,"%c",p);
				break;
			}
		}
	}
	fprintf(f,"\n");
}

void genbadcase(FILE *f, int l){
	nul(a);
	int pairs = rand()%729 +1;
	char last = 'a';
	fprintf(f,"%d\n",pairs);
	int tek = 0;
	for (int i = 0 ; i<l ; i++){
		int c;
		while (true){
			if (rand()%1000<200)
				c = 0;
			else
				c = rand()%26+1;
			if (!a[last][c]){
				char p;
				tek++;
				if (c==0){
					p = ' ';
				} else
					p = 'A'+c-1;
				fprintf(f,"%c",p);
				a[last][c] = true;
				break;
			} else{
				char p;
				if (c==0){
					p = ' ';
				} else
					p = 'A'+c-1;
				fprintf(f,"%c",p);
				break;
			}
		}
	}
	fprintf(f,"\n");
}

void gentest(int l){
	char name[maxl];
	sprintf(name,"%0*d",2,l/100);
	FILE *f = fopen(name,"w");
	fprintf(f,"5\n");
	genrandomcase(f,l);
	gengoodcase(f,l);
	genbadcase(f,l);
	gengoodcase(f,l);
	genbadcase(f,l);
	fclose(f);
}

int main(){
	for (int i = 1 ; i<=10 ; i++){
		gentest(i*100);
	}
	return 0;
}